#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static int bytea_codelen[255];

static char base64_table[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\0";

int main(int argc, char **argv)
{
  int i;

  printf("#ifndef __BYTEA_CODES__\n#define __BYTEA_CODES__\n\n");
      
  printf("static char *bytea_codes[] = {\n\t\"\\\\\\\\000\",\n");
  bytea_codelen[0] = 5;
      
  for(i = 1; i < 256; i++)
    {
      if(strchr(base64_table,i))
	{
	  printf("\t\"%c\"",i);
	  bytea_codelen[i] = 1;
	}
      else
	{
	  printf("\t\"\\\\%03o\"",i);
	  bytea_codelen[i] = 4;
	}
      if(i < 255) printf(",");
      printf("\n");
    }
      
  printf("};\n\n");

  printf("static int bytea_codelen[] = {\n");
      
  for(i = 0; i < 256; i++)
    {
      printf("\t%d", bytea_codelen[i]);
	  
      if(i < 255) printf(",");
      printf("\n");
    }
      
  printf("};\n\n");

  printf("static char base64_enc_table[]=\"%s\\0\";\n\n", base64_table);
  printf("static unsigned char base64_dec_table[] = {\n");
  for(i = 0; i < 256; i++)
    {
      char *pos;
      
      if(pos = strchr(base64_table,i))
	{
	  printf("\t%d", pos - base64_table);
	}
      else printf("\t255");
      if(i < 255) printf(",");
      printf("\n");
    }
  printf("};\n\n");
  
  printf("\n#endif\n");
  exit(0);
}

